/*  This file is part of Structured Prediction (SP) - http://www.alexander-schwing.de/
 *
 *  Structured Prediction (SP) is free software: you can
 *  redistribute it and/or modify it under the terms of the GNU General
 *  Public License as published by the Free Software Foundation, either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  Structured Prediction (SP) is distributed in the hope
 *  that it will be useful, but WITHOUT ANY WARRANTY; without even the
 *  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Structured Prediction (SP).
 *  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2010-2013  Alexander G. Schwing  [http://www.alexander-schwing.de/]
 */

//Author: Alexander G. Schwing

/*  ON A PERSONAL NOTE: I spent a significant amount of time to go through
 *  both, theoretical justifications and coding of this framework.
 *  I hope the package is useful for your task. Any citations, requests, 
 *  feedback, donations and support would be greatly appreciated.
 *  Thank you for contacting me!
 */

struct SampleParams {
	std::string fn;
};

struct TrainingDataParams {
	std::vector<struct SampleParams*> SampleData;
};

class TrainingSample {
	struct SampleParams* sample;
	typedef std::vector<int> LABEL_VAR;//adapt according to your needs
	LABEL_VAR labeling;
	LABEL_VAR gt;
	std::vector<double> phi_gt;
public:
	TrainingSample() {};
	~TrainingSample() {};
	
	int Load(struct SampleParams* sample) {
		this->sample = sample;
		int numFeatures = 2;
		//assign required data and set the annotated variables within gt
		
		return numFeatures;
	}
	int MarginRescaling(std::vector<double>& w, double time) {
		//compute margin rescaling and assign labeling
		return 0;
	}
	int PredictLatent(std::vector<double>& w) {
		int numFeatures = int(w.size());
		//predict latent variables (if available) using w and update gt

		//compute feature vector using gt (which now contains a label (either annotated or predicted) for every variable)
		phi_gt.assign(numFeatures, 0.0);
		FeatureVector(gt, phi_gt);
		return 0;
	}
	int FeatureVector(LABEL_VAR& y, std::vector<double>& phi) {
		//compute feature vector phi from labeling y
		return 0;
	}
	double Loss() {
		double loss = 0.0;
		//compute loss of labeling w.r.t. annotated(!) gt
		return loss;
	}
	int AddFeatureDiffAndLoss(std::vector<double>& featureDiffAndLoss, std::vector<double>& w) {
		int numFeatures = int(featureDiffAndLoss.size())-1;
		std::vector<double> phi_y(numFeatures, 0.0);
		FeatureVector(labeling, phi_y);
		for(int k=0;k<numFeatures;++k) {
			featureDiffAndLoss[k] += phi_gt[k] - phi_y[k];
		}
		featureDiffAndLoss[numFeatures] += Loss();
		return 0;
	}
};